<!DOCTYPE html>
<html lang="en">

<head>
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  <title>VChatBox</title>
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css"
    integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
</head>

<body>
  <header>
    <div class="container-fluid" style="text-align: center; margin: 0 0 40px 0; color: #7b1fa2">
      <h1>Welcome to VChatBox</h1>
    </div>
  </header>
  <div class="container">
    <div class="row">
      <div class="col-sm">
        <h3 style='color: #ccc;font-size: 30px;'>No message yet..</h3>
        <div class="message_holder container"></div>
      </div>
      <div class="col-sm">

        <!-- <form action="" method="POST">
                    <input type="text" class="username" placeholder="User Name" />
                    <input type="text" class="message" placeholder="Messages" />
                    <input type="submit" />
                  </form> -->
        <form>
          <div class="form-group">
            <label for="exampleInputEmail1">Username</label>
            <input type="text" class="username form-control" id="exampleInputEmail1" aria-describedby="emailHelp"
              placeholder="Username">
          </div>
          <div class="form-group">
            <label for="exampleInputPassword1">Message</label>
            <input type="text" class="message form-control" id="exampleInputPassword1"
              placeholder="Type a message here">
          </div>
          <button type="submit" class="btn btn-primary">Submit</button>
        </form>
       <button onclick="localStorage.clear()" class="btn btn-primary">Clear</button>  

      </div>
    </div>
  </div>

  <!-- jQuery (necessary for Bootstrap's JavaScript plugins) -->
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.12.4/jquery.min.js"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/socket.io/1.7.3/socket.io.min.js"></script>
  <script type="text/javascript">
  function playSound(filename){

        var mp3Source = '<source src="/static/sound.mp3" type="audio/mpeg">';

        var embedSource = '<embed hidden="true" autostart="true" loop="false" src="/static/sound.mp3">';

        document.getElementById("sound").innerHTML='<audio autoplay="autoplay">' + mp3Source + embedSource + '</audio>';

      }

    var socket = io.connect('http://' + document.domain + ':' + location.port);
    socket.on('connect', function () {
      socket.emit('my event', {
        data: 'User Connected'
      })

      if (typeof (Storage) !== "undefined") {
        if (!localStorage.getItem('messages')) {  
          messages = [];
          localStorage.setItem('messages', JSON.stringify(messages));
        }
        else {
            var userDetails = JSON.parse(localStorage.getItem("messages"));
            if (userDetails.length != 0)  $('h3').remove();
            console.log(userDetails)
            for (i in userDetails) {
              $('div.message_holder').append('<div class="alert alert-success" role="alert"><b style="color: #000">' + userDetails[i]["user"] + '</b> ' + userDetails[i]["message"] + '</div>')
            }
        }
      } else {
        console.log("No support for local storage")
      }

      var form = $('form').on('submit', function (e) {
        e.preventDefault()
        let user_name = $('input.username').val()
        let user_input = $('input.message').val()
        if (user_name == '' || user_input == '') {
          alert('Input can not be left blank');
        }
        else {
          var send_data = {
            user: user_name,
            message: user_input
          }
          socket.emit('my event', send_data)
          var messages = JSON.parse(localStorage.getItem("messages"));
          messages.push(send_data);
          localStorage.setItem("messages", JSON.stringify(messages));
          $('input.message').val('').focus()
        }
      })
    })
    socket.on('my response', function (msg) {
      if (typeof msg.user !== 'undefined') {
        $('h3').remove()
        playSound('bing');
        $('div.message_holder').append('<div class="alert alert-success" role="alert"><b style="color: #000">' + msg.user + '</b> ' + msg.message + '</div>')
      }
    })
  </script>
  <script src="https://code.jquery.com/jquery-3.3.1.slim.min.js"
    integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo"
    crossorigin="anonymous"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js"
    integrity="sha384-UO2eT0CpHqdSJQ6hJty5KVphtPhzWj9WO1clHTMGa3JDZwrnQq4sF86dIHNDz0W1"
    crossorigin="anonymous"></script>
  <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js"
    integrity="sha384-JjSmVgyd0p3pXB1rRibZUAYoIIy6OrQ6VrjIEaFf/nJGzIxFDsf4x0xIM+B07jRM"
    crossorigin="anonymous"></script>
    <div id="sound"></div>
</body>

</html>